unit UFPuntuales;

interface
uses
  XComun;
  
procedure XFP_Neg(const M1: XMat; var M2 : XMat);
procedure XFP_Gris(const M1: XMat; var M2 : XMat);
procedure XFP_Umbral(const M1: XMat; var M2 : XMat); overload;
procedure XFP_Umbral(const M1: XMat; var M2 : XMat; umb : single); overload;

implementation

// negativo
procedure XFP_Neg(const M1: XMat; var M2 : XMat);
var
  x,y,k : integer;
begin
  UG_CopiaM2M(M1,M2);

  for k := 0 to 2 do if _kan[k]
  then
    for y := _y1 to _y2 - 1 do
      for x := _x1 to _x2 - 1 do
        M2.dat[x][y][k] := _Lambda - M1.dat[x][y][k]
end;

// Grises
procedure XFP_Gris(const M1: XMat; var M2 : XMat);
var
  x,y,k : integer;
  sum   : single;
begin
  UG_CopiaM2M(M1,M2);

  for y := _y1 to _y2 - 1 do
    for x := _x1 to _x2 - 1 do begin
      sum := 0.0;
      for k := 0 to 2 do sum := sum + M1.dat[x][y][k];
      sum := sum/3;
      for k := 0 to 2 do M2.dat[x][y][k] := sum;
    end;
end;

// Umbraliza
procedure XFP_Umbral(const M1: XMat; var M2 : XMat);
var
  x,y,k : integer;
  U     : single;
begin
  U := _lambda/2;

  UG_CopiaM2M(M1,M2);

  for k := 0 to 2 do if _kan[k]
  then
    for y := _y1 to _y2 - 1 do
      for x := _x1 to _x2 - 1 do
        if M1.dat[x][y][k] < U
          then M2.dat[x][y][k] := 0
          else M2.dat[x][y][k] := _Lambda;

end;

procedure XFP_Umbral(const M1: XMat; var M2 : XMat; umb : single);
var
  x,y,k : integer;
begin
  UG_CopiaM2M(M1,M2);

  for k := 0 to 2 do if _kan[k]
  then
    for y := _y1 to _y2 - 1 do
      for x := _x1 to _x2 - 1 do
        if M1.dat[x][y][k] < umb
          then M2.dat[x][y][k] := 0
          else M2.dat[x][y][k] := _Lambda;
end;

end.
